class Module
  def memoize n, *arr
    ([n] + arr).each do |m|
      meth = instance_method(m)
      hash = Hash.new
      define_method m do |*args|
        if hash.include? args
          hash[args]
        else
          meth = meth.bind(self) if meth.is_a? UnboundMethod
          v = hash[args] = meth.call(*args)
          v.freeze
          v
        end
      end
    end
  end

  def cmemoize n, *m
    singleton_class.memoize n, *m
  end
end

# Let's make "main:Object" methods memoizable
def memoize n, *m
  singleton_class.memoize n, *m
end
